#define UL 3
#define VL 4
#define WL 5
#define UH 2
#define VH 6
#define WH 7

#define MC_MASK ((1<<UL)|(1<<VL)|(1<<WL)|(1<<UH)|(1<<VH)|(1<<WH))

//PORT CONTROL REGISTER FOR DRIVE STAGES
#define PORT_MC PORTL
#define DDR_MC 	DDRL
#define PIN_MC	PINL


//HALL SENSOR INPUT PINS

#define HALL1 0
#define HALL2 1
#define HALL3 2
#define HALL_MASK ((1<<HALL1)|(1<<HALL2)|(1<<HALL3))

//PORT REGISTERS FOR HALL SENSOR INPUT

#define PORT_HALL PORTJ
#define DDR_HALL DDRJ
#define PIN_HALL PINJ

//Clockwise Pattern


#define PATTERN_DRV_OFFSET  0 //!< Offset for drive pattern in table.
#define PATTERN_COM5_OFFSET 6 //!< Offset for Timer 0 Output Compare config pattern in table.

#define PDP1_CW  ((0<<UL)|(0<<VL)|(1<<WL)|(0<<UH)|(1<<VH)|(0<<WH))
#define PDP2_CW  ((0<<UL)|(0<<VL)|(1<<WL)|(1<<UH)|(0<<VH)|(0<<WH))
#define PDP3_CW  ((0<<UL)|(1<<VL)|(0<<WL)|(1<<UH)|(0<<VH)|(0<<WH))
#define PDP4_CW  ((0<<UL)|(1<<VL)|(0<<WL)|(0<<UH)|(0<<VH)|(1<<WH))
#define PDP5_CW  ((1<<UL)|(0<<VL)|(0<<WL)|(0<<UH)|(0<<VH)|(1<<WH))
#define PDP6_CW  ((1<<UL)|(0<<VL)|(0<<WL)|(0<<UH)|(1<<VH)|(0<<WH))

#define UL_ON ((1<<COM5A1)|(0<<COM5A0))
#define UL_OFF ((0<<COM5A0)|(0<<COM5A0))
#define VL_ON ((1<<COM5B1)|(0<<COM5B0))
#define VL_OFF ((0<<COM5B0)|(0<<COM5B0))
#define WL_ON ((1<<COM5C1)|(0<<COM5C0))
#define WL_OFF ((0<<COM5C0)|(0<<COM5C0))

#define COM5P1_CW (UL_OFF)|(VL_OFF)|(WL_ON)|(1<<WGM51)|(0<<WGM50)
#define COM5P2_CW (UL_OFF)|(VL_OFF)|(WL_ON)|(1<<WGM51)|(0<<WGM50)
#define COM5P3_CW (UL_OFF)|(WL_OFF)|(VL_ON)|(1<<WGM51)|(0<<WGM50)
#define COM5P4_CW (UL_OFF)|(WL_OFF)|(VL_ON)|(1<<WGM51)|(0<<WGM50)
#define COM5P5_CW (WL_OFF)|(VL_OFF)|(UL_ON)|(1<<WGM51)|(0<<WGM50)
#define COM5P6_CW (WL_OFF)|(VL_OFF)|(UL_ON)|(1<<WGM51)|(0<<WGM50)

#define HP1 ((1<<HALL1)|(0<<HALL2)|(1<<HALL3))
#define HP2 ((1<<HALL1)|(0<<HALL2)|(0<<HALL3))
#define HP3 ((1<<HALL1)|(1<<HALL2)|(0<<HALL3))
#define HP4 ((0<<HALL1)|(1<<HALL2)|(0<<HALL3))
#define HP5 ((0<<HALL1)|(1<<HALL2)|(1<<HALL3))
#define HP6 ((0<<HALL1)|(0<<HALL2)|(1<<HALL3))