
#pragma used+
sfrb PINA=0;
sfrb DDRA=1;
sfrb PORTA=2;
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb PINE=0xc;
sfrb DDRE=0xd;
sfrb PORTE=0xe;
sfrb PINF=0xf;
sfrb DDRF=0x10;
sfrb PORTF=0x11;
sfrb PING=0x12;
sfrb DDRG=0x13;
sfrb PORTG=0x14;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb TIFR3=0x18;
sfrb TIFR4=0x19;
sfrb TIFR5=0x1a;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0X21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb OCDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb RAMPZ=0x3b;
sfrb EIND=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned char drvPatternsCW[] = {
0,    

((1<<3)|(0<<4)|(0<<5)|(0<<2)|(0<<6)|(1<<7)),  
((0<<3)|(1<<4)|(0<<5)|(1<<2)|(0<<6)|(0<<7)), 
((0<<3)|(1<<4)|(0<<5)|(0<<2)|(0<<6)|(1<<7)), 
((0<<3)|(0<<4)|(1<<5)|(0<<2)|(1<<6)|(0<<7)), 
((1<<3)|(0<<4)|(0<<5)|(0<<2)|(1<<6)|(0<<7)), 
((0<<3)|(0<<4)|(1<<5)|(1<<2)|(0<<6)|(0<<7)), 
(((0<<2       )|(0<<2       )))|(((0<<4       )|(0<<4       )))|(((1<<7       )|(0<<6       )))|(1<<1       )|(0<<0       ),
(((0<<6       )|(0<<6       )))|(((0<<2       )|(0<<2       )))|(((1<<5       )|(0<<4       )))|(1<<1       )|(0<<0       ),
(((0<<6       )|(0<<6       )))|(((0<<2       )|(0<<2       )))|(((1<<5       )|(0<<4       )))|(1<<1       )|(0<<0       ),
(((0<<6       )|(0<<6       )))|(((0<<4       )|(0<<4       )))|(((1<<3       )|(0<<2       )))|(1<<1       )|(0<<0       ),
(((0<<2       )|(0<<2       )))|(((0<<4       )|(0<<4       )))|(((1<<7       )|(0<<6       )))|(1<<1       )|(0<<0       ),
(((0<<6       )|(0<<6       )))|(((0<<4       )|(0<<4       )))|(((1<<3       )|(0<<2       )))|(1<<1       )|(0<<0       )                    
};

unsigned char *pDrvPattern;

unsigned int word;

unsigned char hallMask;

void init_timer5(void)
{
(*(unsigned char *) 0x120)=(1<<7       )|(0<<6       )|(1<<5       )|(0<<4       )|(1<<3       )|(0<<2       )|(1<<1       )|(0<<0       );
(*(unsigned char *) 0x121)=(0<<7       )|(0<<6       )|(1<<4       )|(1<<3       )|(1<<2       )|(0<<1       )|(0<<0       );
(*(unsigned char *) 0x127)=0x01;
(*(unsigned char *) 0x126)=0x03;
(*(unsigned char *) 0x125) = 0;
(*(unsigned char *) 0x124) = 0;
TIFR5 = TIFR5;
}

interrupt [11] void pinchange_interrupt_isr1()
{
unsigned char *pTemp;
word = ((*(unsigned char *) 0x103)&hallMask);
pTemp = pDrvPattern + word;
(*(unsigned char *) 0x120)=0;
(*(unsigned char *) 0x10b) = *(pTemp);
(*(unsigned char *) 0x120) = *(pTemp+6 );
}
void init_pin_change_int(void)
{
(*(unsigned char *) 0x6b)=0x00;
(*(unsigned char *) 0x6c)=0x0E;
(*(unsigned char *) 0x6d)=0x00;
(*(unsigned char *) 0x68)=0x02;
PCIFR=0x02;

}
void main(void)

{ 
init_timer5();
pDrvPattern = drvPatternsCW;
hallMask = ((1<<0)|(1<<1)|(1<<2));
init_pin_change_int();
(*(unsigned char *) 0x104) |= ((1<<0)|(1<<1)|(1<<2));    
(*(unsigned char *) 0x105) |= ((1<<0)|(1<<1)|(1<<2));
(*(unsigned char *) 0x105) &= ~((1<<0)|(1<<1)|(1<<2));  
(*(unsigned char *) 0x104) &= ~((1<<0)|(1<<1)|(1<<2)); 
#asm("sei");
(*(unsigned char *) 0x129)=0x01;
(*(unsigned char *) 0x128)=0x03;
(*(unsigned char *) 0x12b)=0x01;
(*(unsigned char *) 0x12a)=0x03;
(*(unsigned char *) 0x12d)=0x01;    
(*(unsigned char *) 0x12c)=0x03;
(*(unsigned char *) 0x10a) = ((1<<3)|(1<<4)|(1<<5)|(1<<2)|(1<<6)|(1<<7));	
while(1);

}
